
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ThinkPHP、ZF2、Yaf、Laravel框架路由大比拼_php技巧 / iVAN</title>

    <meta name="description" content="ThinkPHP、ZF2、Yaf、Laravel框架路由大比拼_php技巧 前言 读过一篇关于Zend Framework2的技术文章&lt;ZF2多级树形路由Route配置实例&gt;,是介绍路由配置的.我觉得很有意思,这是的需求: /user对应用户列表页面 /user/:user_id对应用户的个人主页,比如 /user/AlloVince 就对应AlloVince用户的个人主页 /user/:user_id/blog/对应用户的博客列表页面,比如 /user/AlloVince/blog 就会列出AlloVince写过的Blog /user/:user_id/b ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">ThinkPHP、ZF2、Yaf、Laravel框架路由大比拼_php技巧</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>前言</p>
<p>读过一篇关于Zend Framework2的技术文章《ZF2多级树形路由Route配置实例》，是介绍路由配置的。我觉得很有意思，这是的需求：</p>
<p>/user对应用户列表页面<br />
/user/:user_id对应用户的个人主页，比如 /user/AlloVince 就对应AlloVince用户的个人主页<br />
/user/:user_id/blog/对应用户的博客列表页面，比如 /user/AlloVince/blog 就会列出AlloVince写过的Blog<br />
/user/:user_id/blog/:blog_id对应用户的一篇博客文章<br />
方案引用自原文：</p>
<pre>
'router' =&gt; array(
  'routes' =&gt; array(
    'user' =&gt; array(
      'type' =&gt; 'Segment',
      'options' =&gt; array(
        'route' =&gt; '/user[/]',
        'defaults' =&gt; array(
          'controller' =&gt; 'UserController',
          'action' =&gt; 'index',
        ),
      ),
      'may_terminate' =&gt; true,
      'child_routes' =&gt; array(
        'profile' =&gt; array(
          'type' =&gt; 'Segment',
          'options' =&gt; array(
            'route' =&gt; '[:id][/]',
            'constraints' =&gt; array(
              'id' =&gt; '[a-zA-Z0-9_-]+'
            ),
            'defaults' =&gt; array(
              'action' =&gt; 'get'
            ),
          ),
          'may_terminate' =&gt; true,
          'child_routes' =&gt; array(
            'blog' =&gt; array(
              'type' =&gt; 'Segment',
              'options' =&gt; array(
                'route' =&gt; 'blog[/]',
                'constraints' =&gt; array(
                ),
                'defaults' =&gt; array(
                  'action' =&gt; 'blog'
                )
              ),
              'may_terminate' =&gt; true,
              'child_routes' =&gt; array(
                'post' =&gt; array(
                  'type' =&gt; 'Segment',
                  'options' =&gt; array(
                    'route' =&gt; '[:post_id][/]',
                    'constraints' =&gt; array(
                      'post_id' =&gt; '[a-zA-Z0-9_-]+'
                    ),
                    'defaults' =&gt; array(
                      'action' =&gt; 'post'
                    )
                  ),
                  'may_terminate' =&gt; true,
                ),
              ),
            ),
          ), //profile child_routes end
        ), //profile end
      ), //user child_routes end
    ), //user end
  ),
),
</pre>
<p>看了这篇文章后，我打算使用我用过的PHP框架来实现这个路由需求。</p>
<p><strong>ThinkPHP</strong></p>
<p>新建一个ThinkPHP项目：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>composer create-project topthink/thinkphp tp --prefer-dist</p>
<p>命令行显示我安装的是3.2.2</p>
<p>Installing topthink/thinkphp (3.2.2)<br />
我看ThinkPHP官网最新稳定版本是3.2.3。</p>
<p>我特意去packagist官网查了一下，库中稳定版确实是3.2.2。</p>
<p>我得使用3.2.3。为什么我特别纠结这一点哩？因为：</p>
<p>3.2的路由功能是针对模块设置的，所以URL中的模块名不能被路由，路由定义也通常是放在模块配置文件中。 3.2.3版本开始增加全局路由定义支持，可以在项目的公共配置文件中定义路由。<br />
也就是说，路由重写的部分是Controller和Action部分，Moudle还是存在。</p>
<p>我希望的是/user，而不是home/user。（ThinkPHP中默认Module是Home，'DEFAULT_MODULE' =&gt; 'Home'，可以修改）</p>
<p>当然，这个问题也可以修改.htaccess文件的解决。但是，我还是决定安装3.2.3。</p>
<p>在ThinkPHP官网下载最新的包，解压。</p>
<p>使用浏览器访问一下项目的入口文件，让ThinkPHP自动生成了一个默认的应用模块Home。</p>
<p>修改公共配置文件tp\Application\Common\Conf\config.php：</p>
<pre>
&lt;?php
return array(
  // 开启路由
  'URL_ROUTER_ON' =&gt; true,
  // URL访问模式,可选参数0、1、2、3,代表以下四种模式：
  // 0 (普通模式); 1 (PATHINFO 模式); 2 (REWRITE 模式); 3 (兼容模式) 默认为PATHINFO 模式
  'URL_MODEL' =&gt; 2,
  // URL伪静态后缀设置，为空表示可以支持所有的静态后缀
  // 使用U函数生成URL时会不带后缀
  'URL_HTML_SUFFIX' =&gt; '',
  // URL变量绑定到Action方法参数，默认为true
  'URL_PARAMS_BIND' =&gt; true,
  // URL变量绑定的类型 0 按变量名绑定 1 按变量顺序绑定，默认为0
  'URL_PARAMS_BIND_TYPE' =&gt; 0,
  // 路由配置
  'URL_ROUTE_RULES' =&gt; array(
    '/^url$/' =&gt; 'Home/User/url',
    '/^user$/' =&gt; 'Home/User/index',
    '/^user\/([a-zA-Z0-9_-]+)$/' =&gt; 'Home/User/show?name=:1',
    '/^user\/([a-zA-Z0-9_-]+)\/blog$/' =&gt; 'Home/Blog/index?name=:1',
    '/^user\/([a-zA-Z0-9_-]+)\/blog\/([0-9]+)$/' =&gt; 'Home/Blog/show?name=:1&amp;blog_id=:2',
  ),
);
?&gt;
</pre>
<p>创建文件tp\Application\Home\Controller\UserController.class.php：</p>
<pre>
&lt;?php
namespace Home\Controller;
use Think\Controller;
class UserController extends Controller {
  public function url() {
    $name = 'jing';
    $blogId = 1;
    $urls = array(
      U('/user'),
      U("/user/{$name}"),
      U("/user/{$name}/blog"),
      U("/user/{$name}/blog/{$blogId}"),
    );
    foreach ($urls as $url) {
      echo "&lt;a href=\"{$url}\"&gt;{$url}&lt;a/&gt;&lt;br /&gt;\n";
    }
  }
  public function index() {
    echo '我是用户列表^_^';
  }
  public function show($name) {
    echo "欢迎你，{$name}";
  }
}
?&gt;
</pre>
<p>创建文件tp\Application\Home\Controller\BlogController.class.php：</p>
<pre>
&lt;?php
namespace Home\Controller;
use Think\Controller;
class BlogController extends Controller {
  public function index($name) {
    echo "这是{$name}的博客列表";
  }
  public function show($blog_id, $name) {
    echo "{$name}的这篇博客的id为{$blog_id}";
  }
}
?&gt;
</pre>
<p>访问：http://127.0.0.1/tp/url</p>
<p>输出：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;a href="/tp/user"&gt;/tp/user&lt;a/&gt;&lt;br /&gt;<br />
&lt;a href="/tp/user/jing"&gt;/tp/user/jing&lt;a/&gt;&lt;br /&gt;<br />
&lt;a href="/tp/user/jing/blog"&gt;/tp/user/jing/blog&lt;a/&gt;&lt;br /&gt;<br />
&lt;a href="/tp/user/jing/blog/1"&gt;/tp/user/jing/blog/1&lt;a/&gt;&lt;br /&gt;</p>
<p>访问上面4个链接，依次返回：</p>
<p>我是用户列表^_^<br />
欢迎你，jing<br />
这是jing的博客列表<br />
jing的这篇博客的id为1<br />
下面其他框架，也同样输出以上内容。</p>
<p><strong>Zend Framework 2</strong></p>
<p>使用ZF2骨架程序创建一个ZF2项目：</p>
<p>composer create-project --stability="dev" zendframework/skeleton-application zf2</p>
<p>修改默认模块Application的配置文件zf2\module\Application\config\module.config.php：</p>
<pre>
&lt;?php
/**
 * Zend Framework (http://framework.zend.com/)
 *
 * @link   http://github.com/zendframework/ZendSkeletonApplication for the canonical source repository
 * @copyright Copyright (c) 2005-2015 Zend Technologies USA Inc. (http://www.zend.com)
 * @license  http://framework.zend.com/license/new-bsd New BSD License
 */
return array(
  'router' =&gt; array(
    'routes' =&gt; array(
      'home' =&gt; array(
        'type' =&gt; 'Zend\Mvc\Router\Http\Literal',
        'options' =&gt; array(
          'route' =&gt; '/url',
          'defaults' =&gt; array(
            'controller' =&gt; 'Application\Controller\User',
            'action' =&gt; 'url',
          ),
        ),
      ),
      // The following is a route to simplify getting started creating
      // new controllers and actions without needing to create a new
      // module. Simply drop new controllers in, and you can access them
      // using the path /application/:controller/:action
      'application' =&gt; array(
        'type' =&gt; 'Literal',
        'options' =&gt; array(
          'route' =&gt; '/application',
          'defaults' =&gt; array(
            '__NAMESPACE__' =&gt; 'Application\Controller',
            'controller' =&gt; 'Index',
            'action' =&gt; 'index',
          ),
        ),
        'may_terminate' =&gt; true,
        'child_routes' =&gt; array(
          'default' =&gt; array(
            'type' =&gt; 'Segment',
            'options' =&gt; array(
              'route' =&gt; '/[:controller[/:action]]',
              'constraints' =&gt; array(
                'controller' =&gt; '[a-zA-Z][a-zA-Z0-9_-]*',
                'action' =&gt; '[a-zA-Z][a-zA-Z0-9_-]*',
              ),
              'defaults' =&gt; array(
              ),
            ),
          ),
        ),
      ),
      'user_list' =&gt; array(
        'type' =&gt; 'Segment',
        'options' =&gt; array(
          'route' =&gt; '/user[/]',
          'defaults' =&gt; array(
            '__NAMESPACE__' =&gt; 'Application\Controller',
            'controller' =&gt; 'User',
            'action' =&gt; 'index',
          ),
        ),
        'may_terminate' =&gt; true,
        'child_routes' =&gt; array(
          'user' =&gt; array(
            'type' =&gt; 'Segment',
            'options' =&gt; array(
              'route' =&gt; '[:name][/]',
              'constraints' =&gt; array(
                'name' =&gt; '[a-zA-Z0-9_-]+',
              ),
              'defaults' =&gt; array(
                'action' =&gt; 'show',
              ),
            ),
            'may_terminate' =&gt; true,
            'child_routes' =&gt; array(
              'blog_list' =&gt; array(
                'type' =&gt; 'Segment',
                'options' =&gt; array(
                  'route' =&gt; 'blog[/]',
                  'constraints' =&gt; array(
                  ),
                  'defaults' =&gt; array(
                    'controller' =&gt; 'Blog',
                    'action' =&gt; 'index',
                  )
                ),
                'may_terminate' =&gt; true,
                'child_routes' =&gt; array(
                  'blog' =&gt; array(
                    'type' =&gt; 'Segment',
                    'options' =&gt; array(
                      'route' =&gt; '[:blog_id]',
                      'constraints' =&gt; array(
                        'blog_id' =&gt; '[0-9]+',
                      ),
                      'defaults' =&gt; array(
                        'action' =&gt; 'show',
                      )
                    ),
                    'may_terminate' =&gt; true,
                  ),
                ),
              ),
            ),
          ),
        ),
      ),
    ),
  ),
  'service_manager' =&gt; array(
    'abstract_factories' =&gt; array(
      'Zend\Cache\Service\StorageCacheAbstractServiceFactory',
      'Zend\Log\LoggerAbstractServiceFactory',
    ),
    'aliases' =&gt; array(
      'translator' =&gt; 'MvcTranslator',
    ),
  ),
  'translator' =&gt; array(
    'locale' =&gt; 'en_US',
    'translation_file_patterns' =&gt; array(
      array(
        'type' =&gt; 'gettext',
        'base_dir' =&gt; __DIR__ . '/../language',
        'pattern' =&gt; '%s.mo',
      ),
    ),
  ),
  'controllers' =&gt; array(
    'invokables' =&gt; array(
      'Application\Controller\Index' =&gt; 'Application\Controller\IndexController',
      'Application\Controller\User' =&gt; 'Application\Controller\UserController',
      'Application\Controller\Blog' =&gt; 'Application\Controller\BlogController',
    ),
  ),
  'view_manager' =&gt; array(
    'display_not_found_reason' =&gt; true,
    'display_exceptions' =&gt; true,
    'doctype' =&gt; 'HTML5',
    'not_found_template' =&gt; 'error/404',
    'exception_template' =&gt; 'error/index',
    'template_map' =&gt; array(
      'layout/layout' =&gt; __DIR__ . '/../view/layout/layout.phtml',
      'application/index/index' =&gt; __DIR__ . '/../view/application/index/index.phtml',
      'error/404' =&gt; __DIR__ . '/../view/error/404.phtml',
      'error/index' =&gt; __DIR__ . '/../view/error/index.phtml',
    ),
    'template_path_stack' =&gt; array(
      __DIR__ . '/../view',
    ),
  ),
  // Placeholder for console routes
  'console' =&gt; array(
    'router' =&gt; array(
      'routes' =&gt; array(
      ),
    ),
  ),
);
?&gt;
</pre>
<p>这个文件是骨架程序中自带的，我只是修改了router部分和controllers部分。要我写这么长的文件，那就太为难我了。这也是ZF官方发布了一个骨架程序的原因。</p>
<p>创建文件zf2\module\Application\src\Application\Controller\UserController.php：</p>
<pre>
&lt;?php
namespace Application\Controller;
use Zend\Mvc\Controller\AbstractActionController;
use Zend\View\Model\ViewModel;
class UserController extends AbstractActionController {
  public function urlAction() {
    $name = 'jing';
    $blogId = 1;
    $urls = array(
      $this-&gt;url()-&gt;fromRoute('user_list'),
      $this-&gt;url()-&gt;fromRoute('user_list/user', array('name' =&gt; $name)),
      $this-&gt;url()-&gt;fromRoute('user_list/user/blog_list', array('name' =&gt; $name)),
      $this-&gt;url()-&gt;fromRoute('user_list/user/blog_list/blog', array('name' =&gt; $name, 'blog_id' =&gt; $blogId)),
    );
    $view = new ViewModel(compact('urls'));
    $view-&gt;setTerminal(true);
    return $view;
  }
  public function indexAction() {
    $view = new ViewModel();
    // 禁用布局模板
    $view-&gt;setTerminal(true);
    return $view;
  }
  public function showAction() {
    $username = $this-&gt;params()-&gt;fromRoute('name');
    $view = new ViewModel(compact('username'));
    $view-&gt;setTerminal(true);
    return $view;
  }
}
?&gt;
</pre>
<p>创建文件zf2\module\Application\src\Application\Controller\BlogController.php：</p>
<pre>
&lt;?php
namespace Application\Controller;
use Zend\Mvc\Controller\AbstractActionController;
use Zend\View\Model\ViewModel;
class BlogController extends AbstractActionController {
  public function indexAction() {
    $username = $this-&gt;params()-&gt;fromRoute('name');
    $view = new ViewModel(compact('username'));
    $view-&gt;setTerminal(true);
    return $view;
  }
  public function showAction() {
    $username = $this-&gt;params()-&gt;fromRoute('name');
    $blogId = $this-&gt;params()-&gt;fromRoute('blog_id');
    $view = new ViewModel(compact('username', 'blogId'));
    $view-&gt;setTerminal(true);
    return $view;
  }
}
?&gt;
</pre>
<p>zf2不支持Action参数绑定，ThinkPHP不仅支持绑定，还支持2种绑定方式：按变量名绑定和按变量顺序绑定。</p>
<p>zf2中Action必须得返回视图，除非exit()。如果你知道可以禁用视图的办法，请告诉我。</p>
<p>创建文件zf2\module\Application\view\application\user\url.phtml：</p>
<pre>
&lt;?php foreach ($urls as $url): ?&gt;
&lt;a href="&lt;?php echo $url;?&gt;"&gt;&lt;?php echo $url;?&gt;&lt;a/&gt;&lt;br /&gt;
&lt;?php endforeach; ?&gt;
</pre>
<p>创建文件zf2\module\Application\view\application\user\index.phtml：</p>
<p>我是用户列表^_^<br />
创建文件zf2\module\Application\view\application\user\show.phtml：</p>
<p>欢迎你，&lt;?php echo $username; ?&gt;<br />
创建文件zf2\module\Application\view\application\blog\index.phtml：</p>
<p>这是&lt;?php echo $username; ?&gt;的博客列表<br />
创建文件zf2\module\Application\view\application\blog\show.phtml：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;?php echo $username; ?&gt;的这篇博客的id为&lt;?php echo $blogId; ?&gt;</p>
<p><strong>Yaf</strong></p>
<p>安装Yaf</p>
<p>使用代码生成工具创建Yaf项目</p>
<p>修改启动文件yaf\application\Bootstrap.php，修改其中的_initRoute方法：</p>
<pre>
    $router = Yaf_Dispatcher::getInstance()-&gt;getRouter();
    $route0 = new Yaf_Route_Rewrite('url', array(
      'controller' =&gt; 'User',
      'action' =&gt; 'url',
        ), array()
    );
    $route1 = new Yaf_Route_Rewrite('user', array(
      'controller' =&gt; 'User',
      'action' =&gt; 'index',
        ), array()
    );
    $route2 = new Yaf_Route_Regex('#user/([a-zA-Z0-9_-]+)#', array(
      'controller' =&gt; 'User',
      'action' =&gt; 'show',
        ), array(1 =&gt; 'name',)
    );
    $route3 = new Yaf_Route_Regex('#user/([a-zA-Z0-9_-]+)/blog#', array(
      'controller' =&gt; 'Blog',
      'action' =&gt; 'index',
        ), array(1 =&gt; 'name',)
    );
    $route4 = new Yaf_Route_Regex('#user/([a-zA-Z0-9_-]+)/blog/([0-9]+)#', array(
      'controller' =&gt; 'Blog',
      'action' =&gt; 'show',
        ), array(1 =&gt; 'name', 2 =&gt; 'blogId',)
    );
    $router-&gt;addRoute('url', $route0);
    $router-&gt;addRoute('user_list', $route1);
    $router-&gt;addRoute('user', $route2);
    $router-&gt;addRoute("blog_list", $route3);
    $router-&gt;addRoute("blog", $route4);
</pre>
<p>Yaf有路由功能，但是没有根据路由名生成URL的方法。所以我定义了一个项目名，用于拼接URL。</p>
<p>在配置文件中添加配置项yaf\conf\application.ini：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>project.name = 'yaf'</p>
<p>创建文件yaf\application\controllers\User.php：</p>
<pre>
&lt;?php
class UserController extends Yaf_Controller_Abstract {
  public function urlAction() {
    $name = 'jing';
    $blogId = 1;
    $app = Yaf_Application::app();
    $projectName = $app-&gt;getConfig()-&gt;project-&gt;name;
    $urls = array(
      "/{$projectName}/user",
      "/{$projectName}/user/{$name}",
      "/{$projectName}/user/{$name}/blog",
      "/{$projectName}/user/{$name}/blog/{$blogId}",
    );
    foreach ($urls as $url) {
      echo "&lt;a href=\"{$url}\"&gt;{$url}&lt;a/&gt;&lt;br /&gt;\n";
    }
    return false;
  }
  public function indexAction() {
    echo '我是用户列表^_^';
    // 禁用视图模板
    return false;
  }
  public function showAction($name) {
    echo "欢迎你，{$name}";
    return false;
  }
}
</pre>
<p>创建文件yaf\application\controllers\Blog.php：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;?php<br />
class BlogController extends Yaf_Controller_Abstract {<br />
    public function indexAction($name) {<br />
        echo "这是{$name}的博客列表";<br />
        return false;<br />
    }<br />
    public function showAction($blogId, $name) {<br />
        echo "{$name}的这篇博客的id为{$blogId}";<br />
        return false;<br />
    }<br />
}</p>
<p>Yaf的Action支持参数绑定，是按变量名绑定的。$name、$blogId要和路由中配置的名称一样，而和参数顺序无关。</p>
<p><strong>Laravel</strong></p>
<p>新建Laravel项目：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>composer create-project laravel/laravel --prefer-dist</p>
<p>清除合并文件。在目录laravel\vendor\下有个文件compiled.php，这个文件是为了减少IO提高框架性能，将很多类文件合并到一个文件中而生存的。在开发环境下，应该删除该文件，否则修改了一些文件发现没有效果，其实是因为文件已经合并缓存了。<br />
清除命令：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>php artisan clear-compiled</p>
<p>在生产环境中应该开启，以提升性能：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>php artisan optimize --force</p>
<p>修改路由文件laravel\app\Http\routes.php：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;?php<br />
Route::get('/url', array('uses' =&gt; 'UserController@getUrl'));<br />
Route::get('/user', array('uses' =&gt; 'UserController@getIndex'));<br />
Route::get('/user/{username}', array('uses' =&gt; 'UserController@getShow'));<br />
Route::get('/user/{username}/blog', array(<br />
    'as' =&gt; 'blog_list',<br />
    'uses' =&gt; 'BlogController@getIndex',<br />
));<br />
Route::get('/user/{username}/blog/{blogId}', array(<br />
    'as' =&gt; 'blog',<br />
    'uses' =&gt; 'BlogController@getShow',<br />
))-&gt;where(array('blogId' =&gt; '[0-9]+'));</p>
<p>查看路由定义情况：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>php artisan route:list</p>
<p>输出：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>+--------+----------+-------------------------------+-----------+----------------------------------------------+------------+<br />
| Domain | Method   | URI                           | Name      | Action                                       | Middleware |<br />
+--------+----------+-------------------------------+-----------+----------------------------------------------+------------+<br />
|        | GET|HEAD | url                           |           | App\Http\Controllers\UserController@getUrl   |            |<br />
|        | GET|HEAD | user                          |           | App\Http\Controllers\UserController@getIndex |            |<br />
|        | GET|HEAD | user/{username}               |           | App\Http\Controllers\UserController@getShow  |            |<br />
|        | GET|HEAD | user/{username}/blog          | blog_list | App\Http\Controllers\BlogController@getIndex |            |<br />
|        | GET|HEAD | user/{username}/blog/{blogId} | blog      | App\Http\Controllers\BlogController@getShow  |            |<br />
+--------+----------+-------------------------------+-----------+----------------------------------------------+------------+</p>
<p>定义路由变量全局模式，修改文件laravel\app\Providers\RouteServiceProvider.php中的boot方法：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>    public function boot(Router $router) {<br />
        $router-&gt;pattern('username', '[a-zA-Z0-9_-]+');<br />
<br />        parent::boot($router);<br />
    }</p>
<p>创建UserController控制器：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>php artisan make:controller UserController</p>
<p>Laravel帮我们在laravel\app\Http\Controllers目录下创建了文件UserController.php，文件中已经为我们写好一部分骨架代码。修改文件laravel\app\Http\Controllers\UserController.php：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;?php<br />
namespace App\Http\Controllers;<br />
use App\Http\Controllers\Controller;<br />
class UserController extends Controller {<br />
    public function getUrl() {<br />
        $name = 'jing';<br />
        $blogId = 1;<br />
        $urls = array(<br />
            url('/user'),<br />
            action('UserController@getShow', array($name)),<br />
            route('blog_list', array($name)),<br />
            route('blog', array($name, $blogId)),<br />
        );<br />
        foreach ($urls as $url) {<br />
            echo "&lt;a href=\"{$url}\"&gt;{$url}&lt;a/&gt;&lt;br /&gt;\n";<br />
        }<br />
    }<br />
    public function getIndex() {<br />
        echo '我是用户列表^_^';<br />
    }<br />
    public function getShow($name) {<br />
        echo "欢迎你，{$name}";<br />
    }<br />
}</p>
<p>创建BlogController控制器：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>php artisan make:controller BlogController</p>
<p>修改文件laravel\app\Http\Controllers\BlogController.php：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;?php<br />
namespace App\Http\Controllers;<br />
use App\Http\Controllers\Controller;<br />
class BlogController extends Controller {<br />
    public function getIndex($name) {<br />
        echo "这是{$name}的博客列表";<br />
    }<br />
    public function getShow($name, $blogId) {<br />
        echo "{$name}的这篇博客的id为{$blogId}";<br />
    }<br />
}</p>
<p>Laravel的Action也支持参数绑定，是按变量顺序绑定的，和变量名无关。</p>
<p><strong>后语</strong></p>
<p>我是Laravel粉，但是我也没有想黑其他框架的意思，大家有兴趣也可以用自己熟悉的框架来实现这个小例子，写了记得@我，语言不限。</p>
<p>以上所述就是本文的全部内容了，希望大家能够喜欢。</p>
<p>请您花一点时间将文章分享给您的朋友或者留下评论。我们将会由衷感谢您的支持！</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索laravel<br />
                    ，                thinkphp<br />
                    ，                路由<br />
                    ，                yaf<br />
                                    ZF2<br />
                                    yaf laravel、yaf yii laravel、yaf 与 thinkphp 对比、yaf thinkphp、yaf和thinkphp，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 15:42:32</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e8%b7%af%e7%94%b1/" title="路由">路由</a>, <a href="https://www.iamivan.net/tag/laravel/" title="laravel">laravel</a>, <a href="https://www.iamivan.net/tag/thinkphp/" title="thinkphp">thinkphp</a>, <a href="https://www.iamivan.net/tag/yaf/" title="yaf">yaf</a>, <a href="https://www.iamivan.net/tag/zf2/" title="ZF2">ZF2</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>ThinkPHP、ZF2、Yaf、Laravel框架路由大比拼_php技巧的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8ZWylb.html" rel="bookmark">Laravel框架路由配置总结、设置技巧大全&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基本路由 您的应用程序的绝大多数路由将在 app/routes.php 文件中定义.Laravel 中最简单的路由由一个 URI 和一个闭包调用组成. 基本 GET 路由 复制代码 代码如下: Route::get('/', function() { return 'Hello World'; }); 基本 POST 路由 复制代码 代码如下: Route::post('foo/bar', function() { return 'Hello World'; }); 注册一个路由以响应所有 HT			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxY3APp.html" rel="bookmark">详解PHP的Yii框架的运行机制及其路由功能&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				运行机制概述每一次 Yii 应用开始处理 HTTP 请求时,它都会进行一个近似的流程. 用户提交指向 入口脚本 web/index.php 的请求. 入口脚本会加载 配置数组 并创建一个 应用 实例用于处理该请求. 应用会通过 request(请求) 应用组件解析被请求的 路由. 应用创建一个 controller(控制器) 实例具体处理请求. 控制器会创建一个 action(动作) 实例并为该动作执行相关的 Filters(访问过滤器). 如果任何一个过滤器验证失败,该动作会被取消. 如果全部			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2ZAOQb.html" rel="bookmark">PHP IDE PHPStorm配置支持友好Laravel代码提示方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PHPStorm神器可以支持更友好的laravel框架代码提示(点击查看),只需要执行如下才做: 第一步:在项目的composer.json中添加如下一行 复制代码 代码如下: &quot;require&quot;: { &quot;laravel/framework&quot;: &quot;5.0.*&quot;,&quot;barryvdh/laravel-ide-helper&quot;:&quot;dev-master&quot;} 第二步:执行composer update 第三步:添加se			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNNxrp.html" rel="bookmark">ThinkPHP php 框架学习笔记&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				花了两个多钟在看 ThinkPHP 框架,不想太过深入的知道它的所有高深理论.单纯想知道怎么可以用起来,可以快捷的搭建一个网站.所以是有选择的看,二个钟后还是一头雾水.于是决定改变学习策略,上官方论坛看其它高人写的民间教程,果然比官方的通俗易懂多了.http://bbs.thinkphp.cn/forumdisplay.php?fid=6 (官方论坛) ThinkPHP 有很多函数通过参数拼凑的方式来组合SQL,如下:$list = $test-&gt;findall('',$fields,'id d			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeRDxNb.html" rel="bookmark">PHP框架性能测试报告&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作为一个PHP开发者,而且是初创企业团队的技术开发者,选择开发框架是个很艰难的事情. 用ThinkPHP的话,招聘一个刚从培训机构出来的开发者就可以上手了,但是性能和后期代码解耦是个让人头疼的事情.不过很多第三方功能不需要自己写,众多大牛已经给铺好路了. 用Laravel的话,传说写起来很爽扩展性也够,但是学习成本有点高,总不能给初级开发者半个月的时间去学习框架吧.而且据说江湖人士透漏,Laravel性能不怎么样,文档也并不是特别丰富. 用Yii的话,语法有点啰嗦,前后端代码分离有点小麻烦,不过			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQYRrOb.html" rel="bookmark">示例详解Laravel的注册重构&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 首先确定用户注册的路由 我们在安装好laravel的时候默认生成的注册是用邮箱进行注册的,并且有些选项不需要,有些还需要加一些表单选项 我们注册的话,并不是可以随便注册的,只有一些超级管理员才能进行注册 首先我们使用上次创建的UserController进行配置,如果没有的话,可以使用php artisan make:controller UserController创建一个控制器类 然后创建两条路由Route::get('register', 'UserController@getReg			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boKDJDb.html" rel="bookmark">逐步提升php框架的性能&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.当前框架存在什么问题      目前主流的框架Zend Framework.Cakephp等都采用了MVC模式,同时实现了URL的路由分配.比如说http://www.xxx.com/user/login就会映射到userController对象中的loginAction方法,http://www.xxx.com/user/register对应为userController对象中的registerAction方法.这样对应的userController对象就很可能是这样的. &lt;?  clas			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKqjZap.html" rel="bookmark">ThinkPHP 表单自动验证运用示例&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用TP 3.2框架 public function add_post(){ //验证规则 $rule=array( array('name','require','请输入姓名',1),//必须验证name ); $m=M('user'); //获取name,sex,contact数据到模型,并验证 if(!$m-&gt;field('name,sex,contact')-&gt;validate($rule)-&gt;create()) $this-&gt;error($m-&gt;getError()			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baa1JJb.html" rel="bookmark">PHP微框架Dispatch简介&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Dispatch是一个PHP小框架.它并没有给你完整的MVC设置,但你可以定义URL规则和方法,以便更好组织应用程序.这对API.简单的站点或原型来说是完美的. 复制代码 代码如下: //包含库include 'dispatch.php';// 定义你的路由get('/greet', function () {//渲染视图render('greet-form');});//post处理post('/greet', function () {$name = from($_POST, 'name')			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrDWvz.html" rel="bookmark" class="title">DIV CSS网页布局中常用的列表元素ul ol li dl dt dd释义</a>
					<div>
						核心提示:DIV CSS网页布局中常用的列表元素ul ol li dl dt dd释义 ol 有序列表 &lt;ol&gt;&lt;li&gt;--&lt;/li&gt;&lt;li&gt;--&lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3nXWz.html" rel="bookmark" class="title">关于百度竟价的五大重点因素</a>
					<div>
						前不久和QQ群里一个朋友聊天,他说去参加了网络营销的培训,然后跟我说起百度竟价的的技巧,大致之意百度竟价非常复杂等等.其实百度竟价一点儿也不复 杂,我一共接手玩百度竟价玩了两年,我个人的感觉是,百度竟 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMylRvb.html" rel="bookmark" class="title">WPF and Silverlight学习笔记（二十）：WPF数据绑定概述</a>
					<div>
						WPF数据绑定为应用程序提供了一种表示数据和与数据交互的简单而又一致的 方法.元素能够以公共语言运行库 (CLR) 对象和 XML 的形式绑定到各种数据源 中的数据. 一.数据绑定的基本概念: 数据绑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7AR3b.html" rel="bookmark" class="title">详解ASP&period;NET中Membership表和阻止DOS攻击</a>
					<div>
						无需关闭站点的情况下如何查询ASP.NET 2.0 Membership表 这种查询会爽快的运行在你的开发环境中: Select * from aspnet_users where UserName  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRvJOz.html" rel="bookmark" class="title">插件系统中跨域调用的性能和&OpenCurlyDoubleQuote;一个简单的性能计数器&rdquo;的使用</a>
					<div>
						系统大概的流程如下:从数据中心接收到数据包(1万~3万(个)/秒,使用WCF)可以被不同的应用场景使 用,每个应用场景的业务逻辑各不相同,而每个场景的接收数据包部分的代码是相同的,于是使用一个容 器将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62m2gM.html" rel="bookmark" class="title">ps怎么去除背景？什么是抠图</a>
					<div>
						  什么是&quot;抠图&quot;?顾名思义,所谓抠图就是从一幅图片中将某一部分截取出来,和另外的背景进行合成.不要小看这一工作,我们生活中的很多图像制品都曾经经过这种加工,例如广告等,需要设计人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvK2Qap.html" rel="bookmark" class="title">PS给VR渲染不足室内照片调出暖暖的灯光光照效果教程</a>
					<div>
						你们看这刚渲染的完未PS的图,都会相信,我是VR新手 你们在看PS过的图,都会相信,我是PS老手 如何在PS中弥补VR渲染的不足?如果你觉得我调整的效果还可以的话,我想,能帮上你的小忙了~~~ 首先你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2aKNb.html" rel="bookmark" class="title">Excel2010中单元格内容和格式怎么删除</a>
					<div>
						  Excel2010中单元格内容和格式怎么删除           首先选中要删除内容格式的单元格,在&quot;开始&quot;菜单&quot;编辑&quot;项中选择&quot;全部清除&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOag4vM.html" rel="bookmark" class="title">怎么样才能让打开的文件夹都用不同的进程</a>
					<div>
						正常情况下系统默认的所有文件用的进程是一样的,不管你打开多少个文件夹,如果有一个文件夹卡死.那么当你强制结束该文件夹的时候,你打开的所有文件夹都会关掉.这是因为文件夹用的是一个进程,如果你把文件夹用不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnY5DAM.html" rel="bookmark" class="title">XP的系统装win7的还需要重新分区吗？</a>
					<div>
						  这是不用分区,下载个win7系统直接在XP下安装win7到C盘.什么样的了. 如果你原来装XP时候c盘是50G+,用来做win7系统分区绰绰有余了.并且不用重新分区,不用格式化其它分区.所以你原来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdeKqM.html" rel="bookmark" class="title">win7下IIS7站点页面无法正常显示的解决方法&lowbar;win服务器</a>
					<div>
						Win7系统的强大和酷炫一直都深受用户们的喜欢,但是有时候在使用过程中一些用户会遇到一些困扰,比如最近我一朋友说他在打开一个ASP网站的时候,IIS可以运行,但是页面图片和FLASH却全部无法显示出来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXjeGp.html" rel="bookmark" class="title">mybaties-Mybaties Update 不允许的操作</a>
					<div>
						问题描述 Mybaties Update 不允许的操作 环境:Spring+Mybaties3.X /** * @param entity * 使用CRUDTemplate操作 */ @UpdateP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZJNwz.html" rel="bookmark" class="title">IE10的恶意软件判断率为99&period;96％</a>
					<div>
						今年五月份,分析公司NSS Labs实验室研究表明,IE10的恶意软件判断率为99.96%,远远超过了谷歌Chrome.Safari.Firefox和Opera,而今日,微软又发布了一项新的数据报告, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6B3jz.html" rel="bookmark" class="title">如果自己生成xml&lpar;用于rss订阅&rpar;</a>
					<div>
						问题描述 在对方用rss阅读软件订阅后,是不是我一更新该xml,对方的软件就会提示更新了? 解决方案 解决方案二:我做过RSS阅读器不是这样的在RSS阅读器里,可以定时更新,手动更新是由客户端控制的解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLm51Rz.html" rel="bookmark" class="title">第一次创业的人通常都有那些能力缺陷？</a>
					<div>
						[回答人:周源,张亮,郭磊,郭欣] 周源,08 年开始创业 1. 识人.很多创业团队的悲剧往往都是在创始人之间不停的争吵产生的,他们对创业方向从开始就没有达成共识,只是在表面上「想到一块去了」,而一起 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOleY3b.html" rel="bookmark" class="title">Android服务器&mdash;&mdash;使用TomCat实现软件的版本检测，升级，以及下载更新进度！</a>
					<div>
						Android服务器--使用TomCat实现软件的版本检测,升级,以及下载更新进度! 算下来,TomCat服务器已经写了很长一段时间了,一直说拿他来搞点事 情,也一直没做,今天刚好有空,交流群还有人请 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3jAvz.html" rel="bookmark" class="title">matlab-MATLAB中如何沿边缘法线方向在边缘左右各取3个点并求得这些点的梯度。（已求得边缘法线方向）</a>
					<div>
						问题描述 MATLAB中如何沿边缘法线方向在边缘左右各取3个点并求得这些点的梯度.(已求得边缘法线方向) clear all;clc; %%%%%%%%%%%%%%%%%%%%%%读入图像%%%%lo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEODXz.html" rel="bookmark" class="title">在用CheckBox控件的时候的问题（新手）</a>
					<div>
						问题描述 就是做个简单的多选题这个是其中一个CheckBox控件的protectedvoidCheckBox1_CheckedChanged(objectsender,EventArgse){if(C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB2Lmb.html" rel="bookmark" class="title">android studio-新手提问：关于校园网连接VPN的问题</a>
					<div>
						问题描述 新手提问:关于校园网连接VPN的问题 昨天安装了Android studio,今天构建完小项目后,一直提示我设置HTTP Proxy,各种搜索 之后,也没成功.最后买了个VPN账号,发现在手 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRevOb.html" rel="bookmark" class="title">c&plus;&plus;-每次读取一个字符存入一个string中，最少读取100个字符，应该如何提高程序的性能？</a>
					<div>
						问题描述 每次读取一个字符存入一个string中,最少读取100个字符,应该如何提高程序的性能? &lt;C++ Primer 第五版&gt;习题9.42 假定你希望每次读取一个字符存入一个strin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDnJ0rM.html" rel="bookmark" class="title">算法-求高数解答二叉树的递归建立问题</a>
					<div>
						问题描述 求高数解答二叉树的递归建立问题 从书上看了一个递归建立二叉树的算法(利用前序遍历建立二叉树).代码如下(这个递归的结束条件是输入一个分号&quot;;&quot;)但是我不明白的是这个分号是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0ndQnz.html" rel="bookmark" class="title">上网本气数已尽？</a>
					<div>
						上网本遭遇了喧嚣退去之后的市场落寞 上网本,经历过出乎意料的爆发性增长,也遭遇了喧嚣退去之后的市场落寞.有一种观点认为,由于功能上的先天性缺陷,再加上超轻薄笔记本的崛起,上网本的发展已经到头了. 但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgLvWM.html" rel="bookmark" class="title">c&num;4 0-C&num;正则表达式如何取出某字符串等于号后的括号前的数据</a>
					<div>
						问题描述 C#正则表达式如何取出某字符串等于号后的括号前的数据 (DESCRIPTION = (ADDRESS_LIST = (ADDRESS = (PROTOCOL = TCP)(HOST = ah ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgABoM.html" rel="bookmark" class="title">徐财源死磕金宇集团&OpenCurlyDoubleQuote;奖金门&rdquo;</a>
					<div>
						近一年来,金宇集团几乎被一个叫徐财源的维权人士牵着鼻子走.徐是一个较真的投资者,去年5月,他质疑&quot;金宇集团挪用283万上市募集资金给董事长张翀宇发奖金&quot;,引发上交所和内蒙古证监局的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RygRz.html" rel="bookmark" class="title">activity-Android 的 Tab 不能正常运行</a>
					<div>
						问题描述 Android 的 Tab 不能正常运行 在 TabActivity 有一个 TabHost,在 TabHost 中有两个选项卡,每个选项卡都有自己的intent.如果一个 tab 改变,在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22Ggrb.html" rel="bookmark" class="title">广域网加速，能否为IT寒冬带来暖暖的火？</a>
					<div>
						2008年是国内IT市场极为艰难的一年,受国内外各方面因素的综合影响,IT市场整体需求下滑,而传统的网络产品的价格却越来越透明,竞争越来越大,产品利润越来越低,不少中小渠道已经开始逐步放弃了IT业务转 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBkoBz.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;6&CenterDot;18&rdquo;网首个专业子网站装备制造网开通</a>
					<div>
						28日,&quot;6·18&quot;网首个专业子网站装备制造网开通,并在线推出装备制造行业对接会. 对接会共征集到项目成果248项.企业技术需求81项,其中,成熟度处于中试及产业化阶段的成果111 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4el3Pb.html" rel="bookmark" class="title">保护个人地理信息安全 让&OpenCurlyDoubleQuote;我的坐标我做主&rdquo;</a>
					<div>
						即将于今年7月1日实施的新修订的&lt;中华人民共和国测绘法&gt;,明确将个人地理信息纳入法律保护,引发社会各界对个人地理信息安全的广泛关注.个人地理信息泄露面临哪些风险?该如何保护个人地理信息安全 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkA95Eb.html" rel="bookmark" class="title">域名-mod&lowbar;security的相关问题</a>
					<div>
						问题描述 mod_security的相关问题 如题...使用内网IP访问时规则生效,但是,使用域名访问时,没有任何作用...求解...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOqxqb.html" rel="bookmark" class="title">Visual Studio 2015和 &period;NET Core安装教程&lowbar;实用技巧</a>
					<div>
						安装 Visual Studio 和 .NET Core 1.安装 Visual Studio Community 2015,选择 Community 下载并执行默认安装,Visual Studio  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.040 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
